%define php_sapi cgi

Name: php-cgi
Version: %php_version
Release: %php_release
Summary: The PHP4 HTML-embedded scripting language as a CGI binary.
Group: System/Servers
Url: http://www.php.net/
License: PHP
%add_serial php-devel

Requires: zlib, php-libs = 1:%php_version-%php_release
Requires: control >= 0.6.2

Source1: php.ini.cgi.alt
Source2: %name-browscap.ini
Source3: php.cgi.control

Patch0:	 php-cgi-config9.m4.patch
Patch1:	 php-4.3.12-sapi-cgi.patch

# Automatically added by buildreq on Tue Feb 03 2004
BuildRequires: libexpat-devel zlib-devel libalternatives-devel
BuildRequires: php-libs = 1:%php_version-%php_release 
BuildRequires: php-devel = 1:%php_version-%php_release

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.  
Using PHP as a CGI binary is an option for setups that for some reason 
do not wish to integrate PHP as a module into server software (like Apache), 
or will use PHP with different kinds of CGI wrappers to create safe 
chroot and setuid environments for scripts. 
This setup usually involves installing executable PHP binary to the 
web server cgi-bin directory. CERT advisory CA-96.11 recommends 
against placing any interpreters into cgi-bin.

%prep
%setup -T -c
%php_sapi_prepare %php_sapi

%patch0 -p1
%patch1 -p1 -b .fix

%build
export CFLAGS="%optflags -DDEBUG_FASTCGI"

# fix simple bug.
%__mv config9.m4 config.m4

# some hackaround
%__mkdir_p sapi modules
%__ln_s ../ sapi/%php_sapi
echo -n > modules/z

cd ext/bcmath
phpize 
%configure
cd -

CGI_BUILD_VARS=" \
    install_targets=install-sapi \
    PHP_SAPI=default \
    PHP_MODULES=sapi/%php_sapi/php \
    EXTRA_LIBS=-lphp-%php_version \
    BUILD_DIR=./ \
"

phpize $CGI_BUILD_VARS
%configure \
	--disable-static \
	--enable-cgi \
	--enable-fastcgi \
	--with-php-config=%_bindir/php-config \
	$CGI_BUILD_VARS 

%php_make 

%install
%__mkdir_p \
	%buildroot/%_bindir \
	%buildroot/%php_servicedir/%php_sapi \
	%buildroot/%php_sysconfdir/%php_sapi/php.d \
	%buildroot/%_sysconfdir/control.d/facilities 
	
%php_make_install install-sapi program_suffix=-%php_sapi-%php_version

%__install -m 644 %SOURCE1 %buildroot/%php_sysconfdir/%php_sapi/php.ini
%__install -m 644 %SOURCE2 %buildroot/%php_sysconfdir/%php_sapi/browscap.ini
%__install -m 755 %SOURCE3 %buildroot/%_sysconfdir/control.d/facilities/php4_cgi

%__subst 's,@php_version@,%php_version,g' \
	%buildroot/%php_sysconfdir/%php_sapi/php.ini \
	%buildroot/%_sysconfdir/control.d/facilities/php4_cgi

%__subst 's,@cgibindir@,%apache_cgibindir,g' \
	%buildroot/%php_sysconfdir/%php_sapi/php.ini \
	%buildroot/%_sysconfdir/control.d/facilities/php4_cgi

# Make alternatives support.
%__install -d %buildroot/%_altdir
php_weight="$(echo "%php_version" | sed 's,[^[:digit:]],,g')"

cat << EOF > %buildroot/%_altdir/php4-%php_sapi
%_bindir/php-%php_sapi	%_bindir/php-%php_sapi-%php_version	$php_weight
EOF

%triggerpostun -- php-cgi < 1:4.3.12-alt0.cvs20050530
if ! grep -qs "\<alt_sapi_config_ini_scan_dir\>" "%php_sysconfdir/%php_sapi/php.ini"; then
    printf '\n%%s\n' 'alt_sapi_config_ini_scan_dir = "/etc/php/%php_version/%php_sapi/php.d"' >> "%php_sysconfdir/%php_sapi/php.ini"
fi

%pre
if [ -f "%_altdir/php-cgi-4.3.9.xml" ]; then
    %unregister_alternatives_always php-cgi-4.3.9.xml
fi

%post
%register_alternatives php4-%php_sapi
%php_sapi_postin

%preun
%unregister_alternatives php4-%php_sapi
%php_sapi_preun

%files
%_bindir/php-%php_sapi-%php_version
%_altdir/php4-%php_sapi 
%_sysconfdir/control.d/facilities/*
%config(noreplace) %php_sysconfdir/%php_sapi/php.ini
%php_sysconfdir/%php_sapi
%php_servicedir/%php_sapi
%doc CREDITS

%changelog
* Mon May 30 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050530
- new CVS snapshot;
- new directive added:
  * alt_sapi_config_ini_scan_dir - directory to be scanned for configuration 
    files (default: /etc/php/PHP_VERSION/SAPI/php.d);

* Fri May 27 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050527
- New cvs snapshot;

* Thu Apr 07 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050406
- New cvs snapshot;

* Mon Apr 04 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.12-alt0.cvs20050404
- New cvs snapshot.
- spec cleanup;
- control support added;
- default configuration changed;

* Wed Feb 09 2005 Alexey Gladkov <legion@altlinux.ru> 1:4.3.11-alt0.cvs20050209
- New cvs snapshot.

* Mon Dec 20 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.11-alt0.cvs20041217
- new version;
- alternatives bugfix;

* Fri Aug 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.9-alt0.cvs20040802.1
- php.ini bugfix (#4946);

* Fri Aug 06 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.9-alt0.cvs20040802
- New cvs snapshot;
- security fixes;

* Mon May 31 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040531
- New cvs snapshot;
- Environment variable PHPRC overriding is removed.

* Wed May 26 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040519.1
- Update %%patch1. He was broken.

* Mon May 24 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.7-alt0.cvs20040519
- New cvs snapshot;
- Support alternatives added;
- Remove config files to new place /etc/php/%%php_version/cgi .

* Fri Jan 30 2004 Alexey Gladkov <legion@altlinux.ru> 1:4.3.5-alt0.cvs20040130
- New cvs snapshot.
- Shared Memory support added (enable-shmop).
